--[[
###############
Inked: keivamp#
###############
]]--
local _G = _G;
local unpack    = _G.unpack;
local select    = _G.select;
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local MicroButtons = {}

local MicroMenuMover = CreateFrame("Frame","InkedMicroMenuBarDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MicroMenuMover:SetSize(285,28)
	MicroMenuMover:SetParent(UIParent)
	MicroMenuMover:SetFrameLevel(98)
	--MicroMenuMover:SetPoint(Inked.db.profile.MicroMenuPoint, UIParent,Inked.db.profile.MicroMenuX,Inked.db.profile.MicroMenuY)
	MicroMenuMover:SetClampedToScreen(true)
	MicroMenuMover:SetClampRectInsets(0, 0, 0,0)
	
	local MicroMenuMoverText  = MicroMenuMover:CreateFontString(nil, "OVERLAY")
	MicroMenuMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	MicroMenuMoverText:SetPoint("CENTER",MicroMenuMover,"CENTER", 0,0); 
	MicroMenuMoverText:SetText("")
	
local function UpdateMe()

		if(Inked.db.profile.lockframes == false) then
			if Inked.db.profile.MicroMenuEnabled == true then
				local point, relativeTo, relativePoint, xOfs, yOfs = MicroMenuMover:GetPoint(n)
				Inked.db.profile.MicroMenuX = xOfs
				Inked.db.profile.MicroMenuY = yOfs
				Inked.db.profile.MicroMenuPoint = point
				MicroMenuMoverText:SetText("Micro Menu")
			end
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)
	
	
local function CreateButtonTexture(frame)
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")

	local ButtonForground = CreateFrame("Frame","Foreground",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForground:SetAllPoints(frame)
		  ButtonForground:SetFrameLevel(4)
	local ButtonTexture = ButtonForground:CreateTexture(nil, "BACKGROUND")
		  ButtonTexture:SetAllPoints()
		  ButtonTexture:SetTexture("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
				if Inked.db.profile.ClassMicroMenuColor == true then
						ButtonTexture:SetVertexColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
					elseif Inked.db.profile.ClassMicroMenuColor == false then
						if Inked.db.profile.CustomMicroMenuColor == true then
							ButtonTexture:SetVertexColor(Inked.db.profile.MicroMenuColorR,Inked.db.profile.MicroMenuColorG,Inked.db.profile.MicroMenuColorB,Inked.db.profile.MicroMenuColorA)
						elseif Inked.db.profile.CustomMicroMenuColor == false then
							ButtonTexture:SetVertexColor(1,1,1,1)
						end
					end
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local InkedMicroBar = CreateFrame("Frame", nil, MicroMenuMover, BackdropTemplateMixin and "BackdropTemplate")
InkedMicroBar:SetAllPoints(MicroMenuMover)

local function SetMicroMenu()
	
		for _,button in pairs(MICRO_BUTTONS) do  
			if _G[button]:IsShown() then tinsert(MicroButtons, _G[button]) end 
		end	

		MicroButtons[1]:ClearAllPoints();
		MicroButtons[1]:SetPoint("LEFT", InkedMicroBar,0,0);
		
		for i=1,11 do
				CreateButtonTexture(MicroButtons[i])			
		end
		if Inked.db.profile.MicroMenuShow == false then
			MicroButtons[1]:Hide()
			MicroButtons[2]:Hide()
			MicroButtons[3]:Hide()
			MicroButtons[4]:Hide()
			MicroButtons[5]:Hide()
			MicroButtons[6]:Hide()
			MicroButtons[7]:Hide()
			MicroButtons[8]:Hide()
			MicroButtons[9]:Hide()
			MicroButtons[10]:Hide()
			MicroButtons[11]:Hide()
			StoreMicroButton:SetAlpha(0)
			StoreMicroButton:SetScale(0.0001)
		end
	
	if(Inked.db.profile.lockframes == false) then
			MicroMenuMover:ClearAllPoints()
			if Inked.db.profile.MicroMenuPoint == nil then
				MicroMenuMover:SetPoint("TOPLEFT", Inked.db.profile.MicroMenuX,Inked.db.profile.MicroMenuY)
			else
				MicroMenuMover:SetPoint(Inked.db.profile.MicroMenuPoint, UIParent,Inked.db.profile.MicroMenuX,Inked.db.profile.MicroMenuY)
			end
			if Inked.db.profile.MicroMenuEnabled == true then
				CreateMoverBackdrop(MicroMenuMover)
				MicroMenuMover:SetMovable(true)
				MicroMenuMover:EnableMouse(true)
				MicroMenuMover:RegisterForDrag("LeftButton")
				MicroMenuMover:SetScript("OnDragStart", MicroMenuMover.StartMoving)
				MicroMenuMover:SetScript("OnDragStop", MicroMenuMover.StopMovingOrSizing)
				MicroMenuMover:SetUserPlaced(true)
			end	
		elseif Inked.db.profile.MicroMenuPoint == nil then
				MicroMenuMover:SetPoint("TOPLEFT", Inked.db.profile.MicroMenuX,Inked.db.profile.MicroMenuY)
			else
				MicroMenuMover:SetPoint(Inked.db.profile.MicroMenuPoint, UIParent,Inked.db.profile.MicroMenuX,Inked.db.profile.MicroMenuY)
		end

end
local function walkingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == false) then
	for _,button in pairs(MICRO_BUTTONS) do  
		if _G[button]:IsShown() then tinsert(MicroButtons, _G[button]) end 
	end	
	if Inked.db.profile.MicroMenuShow == true then
		MicroButtons[1]:SetAlpha(1)
		MicroButtons[2]:SetAlpha(1)
		MicroButtons[3]:SetAlpha(1)
		MicroButtons[4]:SetAlpha(1)
		MicroButtons[5]:SetAlpha(1)
		MicroButtons[6]:SetAlpha(1)
		MicroButtons[7]:SetAlpha(1)
		MicroButtons[8]:SetAlpha(1)
		MicroButtons[9]:SetAlpha(1)
		MicroButtons[10]:SetAlpha(1)
		MicroButtons[11]:SetAlpha(1)
		--print("walking")
		end
	end
end
local function ridingFun()
local inVehicle = UnitInVehicle("player")
	if(inVehicle == true) then
	for _,button in pairs(MICRO_BUTTONS) do  
		if _G[button]:IsShown() then tinsert(MicroButtons, _G[button]) end 
	end	
		MicroButtons[1]:SetAlpha(0)
		MicroButtons[2]:SetAlpha(0)
		MicroButtons[3]:SetAlpha(0)
		MicroButtons[4]:SetAlpha(0)
		MicroButtons[5]:SetAlpha(0)
		MicroButtons[6]:SetAlpha(0)
		MicroButtons[7]:SetAlpha(0)
		MicroButtons[8]:SetAlpha(0)
		MicroButtons[9]:SetAlpha(0)
		MicroButtons[10]:SetAlpha(0)
		MicroButtons[11]:SetAlpha(0)
		--print("driving")
	end
end
local function StartBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()

	if(inBattle == true) then
	for _,button in pairs(MICRO_BUTTONS) do  
		if _G[button]:IsShown() then tinsert(MicroButtons, _G[button]) end 
	end	
		--print(inBattle)
		MicroButtons[1]:Hide()
		MicroButtons[2]:Hide()
		MicroButtons[3]:Hide()
		MicroButtons[4]:Hide()
		MicroButtons[5]:Hide()
		MicroButtons[6]:Hide()
		MicroButtons[7]:Hide()
		MicroButtons[8]:Hide()
		MicroButtons[9]:Hide()
		MicroButtons[10]:Hide()
		MicroButtons[11]:Hide()
	end
end
local function EndBattlePetsFun()
local inBattle = C_PetBattles.IsInBattle()
--print(inBattle)
	if(inBattle == false) then
	for _,button in pairs(MICRO_BUTTONS) do  
		if _G[button]:IsShown() then tinsert(MicroButtons, _G[button]) end 
	end	
		if Inked.db.profile.MicroMenuShow == true then
		MicroButtons[1]:Show()
		MicroButtons[2]:Show()
		MicroButtons[3]:Show()
		MicroButtons[4]:Show()
		MicroButtons[5]:Show()
		MicroButtons[6]:Show()
		MicroButtons[7]:Show()
		MicroButtons[8]:Show()
		MicroButtons[9]:Show()
		MicroButtons[10]:Show()
		MicroButtons[11]:Show()
		end
	end
end


	local InkedLoginFrame=CreateFrame("Frame") -- Create the Frame
	InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")--Register the Player Login event
	InkedLoginFrame:RegisterEvent("PET_BATTLE_OPENING_START")
	InkedLoginFrame:RegisterEvent("PET_BATTLE_CLOSE")
	InkedLoginFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
	InkedLoginFrame:RegisterEvent("UNIT_ENTERED_VEHICLE")
	InkedLoginFrame:RegisterEvent("CINEMATIC_START")
	InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
	MicroButtonAndBagsBar:UnregisterAllEvents();
	--hooksecurefunc("MoveMicroButtons", SetMicroMenu)
	InkedLoginFrame:SetScript("OnEvent", function(self, event) -- create the event script	
		if Inked.db.profile.UseActionBars == false then return end
		if Inked.db.profile.MicroMenuEnabled == false then return end
		--hooksecurefunc("MoveMicroButtons", SetMicroMenu)
			SetMicroMenu()
			StartBattlePetsFun()
			EndBattlePetsFun()
			ridingFun()
			walkingFun()
		end)--make sure we close the event scri



